
        .MODEL  SMALL
        .STACK  512

;#########################################################################################################################

        .CONST

        .DATA

color   db      2
lado    dw      0
nivel   dw      200
inicio  dw      32h
coluna  dw      96h

        .DATA?

;#########################################################################################################################

        .CODE

myproc  PROC    FAR

;initialize the data segment

        mov     ax,@DATA
        mov     ds,ax

        mov     ax,4               ;definir o mod grafico modo graf 320x200 color mode
        int     10h                ;invoca a int 10h da BIOS

        mov     ah,11              ;prepara configurao da palete de cores
        mov     bh,0               ;inicializa a cor de background
        mov     bl,1               ;background azul
        int     10h                ;invoca a interrupo 10h da BIOS

        mov     ah,11              ;prepara configurao da palete de cores
        mov     bh,1               ;prepara conf do foreground
        mov     bl,0               ;verde,vermelho e amarelo
        int     10h                ;invoca a intrrupo 10h da Bios

        call    rato
        call    quadrado           ;procedimento que vai desenhar e apagar os quadrados

        mov     ah,0               ;prepara para definir o modo grafico
        mov     al,2               ;repor modo texto.80.25
        int     10h                ;invoca a interrupo 10h da Bios

;terminate program

        mov     ax,4C00h
        int     21h

myproc  ENDP

;#########################################################################################################################

pixeis  PROC    NEAR

;procedimento que vai continuamente fazer cair os pixeis

        push    ax

pix:    call    pixel              ;procedimento que faz cair um pixel
        mov     ax,10
        call    MsDelay

;++++++++++++++++++++++++++++++++chama o procedimento quadrado++++++++++++++++++++++++++++++++++++++++++++++++

        call    quadrado
        jmp     pix

        pop     ax

pixeis  ENDP

;#########################################################################################################################

quadrado PROC   NEAR

;desenhar o rectangulo

quad:   mov     dx,98h             ;selecciona a linha 100
        mov     cx,inicio          ;selecciona a coluna 158
        call    proc1

;++++++++++++++++++++++++++++++chama o procedimento pixeis+++++++++++++++++++++++++++++++++

        call    pixeis

here::  push    dx
        mov     ah,6               ;apenas espera
        mov     dl,0FFh
        int     21h                ;por outra tecla
        pop     dx
        cmp     al,6Eh             ;se for igual a tecla n vai apagar quadrado
        je      apaga

        cmp     al,6Dh             ;se for igual a tecla m vai apagar quadrado
        je      apaga

        cmp     al,0Dh             ;se for ENTER sai do programa
        je      fim

        push    dx
        mov     ah,6               ;apenas espera
        mov     dl,0FFh
        int     21h                ;por outra tecla
        pop     dx
        cmp     al,0Dh             ;enquanto for diferente de ENTER no sai do programa
        jne     here

apaga:  mov     color,0
        mov     ax,10
        call    MsDelay
        sub     ah,ah
        mov     lado,ax
        call    proc1
        mov     color,2
        cmp     lado,6Dh           ;se foi escolhida a tecla para a direita vai ser desenhado o quadrado  direita
        je      inicio2

        cmp     lado,6Eh           ;se foi escolhida a tecla para a esquerda vai ser desenhado o quadrado  esquerda
        je      inicio1

inicio2:add     inicio,10h
        jmp     quad

inicio1:sub     inicio,10h
        jmp     quad

fim:    mov     ah,1               ;apenas espera
        int     21h                ;por outra tecla

quadrado ENDP

;#########################################################################################################################

proc1   PROC    NEAR

        mov     bl,0
        mov     bh,0
   
um:     mov     al,bl
        cmp     al,20              ;compara o valor que esta em AL  igual a  20
        jg      iniciofor2         ;salta se for igual a 20

        call    linha1
        inc     bl
        jmp     um

;linhas na vertical

iniciofor2:
        mov     bl,0               ;inicia for a zero

dois:   mov     al,bl              ;colocar o valor de bl em al
        cmp     al,30              ;compara se o valor que est no al  igual a 30
        jg      iniciofor3

        call    coluna1
        inc     bl
        jmp     dois
   
;linha horizontal

iniciofor3:   
        mov     bl,0               ;coloca o 0 no bl

tres:   mov     al,bl
        cmp     al,20
        jg      iniciofor4         ;salta para inicio4 se for menor  20

        call    linha2             ;seno chama o procedimento linha esquerda, que  para desenhar as linhas
        inc     bl                 ;incrementa o bl
        jmp     tres               ;salta para 3

;++++++++++++++++++++++++linha vertical em comprimentos ao anterior++++++++++++++++++++++++++++++++++++++++

iniciofor4:
        mov     bl,0               ;inicia  a zero

quatro: mov     al,bl
        cmp     al,30              ;nmero de vezes que faz
        jg      sair

        call    coluna2
        inc     bl
        jmp     quatro
   
sair:   ret

        cmp     color,1
        je      muda

        ret

proc1   ENDP                       ;acaba o procedimento proc1

;#########################################################################################################################

muda    PROC    NEAR

        mov     color,2

        jmp     here

        ret

muda    ENDP

;#########################################################################################################################

linha1  PROC    NEAR

        mov     al,color           ;cor dos pontos vermelho, configura
        mov     ah,12              ;conf int 10h para plot do pixel
        inc     dx                 ;vai incrementar o nmero de vezes que for chamado dentro do FOR
        int     10h                ;invoca a int 10h
        ret

linha1  ENDP

;#########################################################################################################################

linha2  PROC    NEAR
   
        mov     al,color           ;cor dos pontos vermelho, configura
        mov     ah,12              ;conf int 10h para plot do pixel
        dec     dx                 ;vai decrementar o nmero de vezes que for chamado dentro do FOR
        int     10h                ;invoca a int 10h
        ret

linha2  ENDP

;#########################################################################################################################

coluna2 PROC    NEAR

        mov     al,color           ;cor dos pontos vermelho, configura
        mov     ah,12              ;conf int 10h para plot do pixel
        inc     cx                 ;vai incrementar o nmero de vezes que for chamado dentro do FOR
        int     10h                ;invoca a int 10h
        ret

coluna2 ENDP

;#########################################################################################################################

coluna1 PROC    NEAR

        mov     al,color           ;cor dos pontos vermelho, configura
        mov     ah,12              ;conf int 10h para plot do pixel
        dec     cx                 ;vai decrementar o nmero de vezes que for chamado dentro do FOR
        int     10h                ;invoca a int 10h
        ret

coluna1 ENDP

;#########################################################################################################################

rato    PROC    NEAR

        mov     ax,0
        int     33h
        mov     ax,1
        int     33h
        ret

rato    ENDP

;#########################################################################################################################

pixel   PROC    NEAR

        push    ax
        push    bx
        mov     ah,2Ch             ;para ir buscar as centsimas de segundo
        int     21h
        sub     dh,dh
        mov     ax,dx              ;para fazer a multiplicao do valor por ah
        mov     cx,0Ah
        mul     cx

;        mov     aleatorio,ax      ;guarda os centesimos de segundo em aleatorio

;o resultado da multiplicao est em ax
;o resto fica em dx
;vai dividir ax por 2BCh

        mov     bx,2BCh
        div     bx
        cmp     dx,12Ch            ;verificar se o resto da divisao  maior q 300
        jg      maior

maior:  mov     coluna,12Ch        ;se o resto da divisao for maior que 300 retorna a coluna 300
        mov     coluna,dx          ;poe o resto da divisao na coluna
        pop     bx
        pop     ax

        mov     dx,10h             ;selecciona a linha 100
        mov     cx,coluna          ;seleciona a coluna

;        mov     dx,64h

        mov     cx,180

game:   push    cx
        mov     al,2               ;pixel cor vermelha
        mov     ah,12
        mov     cx,coluna
        int     10h

;        mov     ah,1
;        int     21h               ;espera por uma tecla

        mov     ax,nivel
        call    MsDelay

        mov     al,0               ;pixel cor preto
        mov     ah,12
        mov     cx,coluna          ;considerando que temos 300 colunas
        int     10h
      
        inc     dx
        pop     cx
        loop    game

pixel   ENDP

;#########################################################################################################################

MsDelay PROC    NEAR

; -----------------------------------------------------------
; This proc delays for the specified number of milliseconds.
; It does this by counting memory refresh requests, which
; for AT-class systems are generated by system timer 1,
; normally programmed by the BIOS to generate an output once
; every 18/1193182 = 15.09 microseconds. Each request toggles
; bit 4 of I/O port 61h. We are counting full cycles of the
; bit, with two toggles per cycle, so each cycle takes 30.18
; microseconds and we count 34 cycles for each millisecond.
;
; Call with the number of milliseconds in AX.
;
; Preserves all registers other than AX.
;
; Note that the delay will be much shorter when running
; under the NT versions of Windows.
; -----------------------------------------------------------

        push    cx
        mov     cx,ax              ;load msLoop count

msLoop: push    cx                 ;preserve msLoop counter
        mov     cx,34              ;load repeat count

wait1:  in      al,61h             ;read byte from port
        test    al,10h             ;test bit 4
        jz      wait1              ;jump if bit clear

wait2:  in      al,61h             ;read byte from port
        test    al,10h             ;test bit 4
        jnz     wait2              ;jump if bit not clear

        dec     cx                 ;decrement repeat count
        jnz     wait1              ;jump if count not zero

        pop     cx                 ;recover msLoop counter
        dec     cx                 ;decrement msLoop count
        jnz     msLoop             ;jump if count not zero

        pop     cx
        ret

MsDelay ENDP

;#########################################################################################################################

        END     myproc             ;entrada es myproc

